// scroll_text_changer.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>

unsigned char firmware_installer[0x80000];

#define scroll_text firmware_installer[scroll_loc+(j++)]

int insert_scroller()
{

	int i,j,k;
	int scroll_loc;
	FILE *f;

	char scroll_text_start[] = {"***SCROLLER TEXT START***"};

	j=firmware_installer[0x2C]+(firmware_installer[0x2D]<<8);
	j+=(firmware_installer[0x2E]<<16)+(firmware_installer[0x2F]<<24);
	j+=0x200;

	for(i=0x200;i<j;i++)
	{
		for(k=0;k<25;k++)
		{
			if(scroll_text_start[k] != firmware_installer[i+k])
				break;
		}
		if(k==25)
			break;
	}
	if(i==j)
	{
		printf("Error: SCROLL_TEXT was not defined in\n");
		printf("installer.nds. Uncomment #define SCROLL_TEXT 1\n");
		printf("in options.h, rebuild firmware and installer, and\n");
		printf("try again\n");
		return 1;
	}
	scroll_loc = i+25;

	f=fopen("scroller.txt","r");
	if(f==NULL)
	{
		printf("Error: scroller.txt not found.\n");
		printf("Create file scroller.txt, put whatever scrolltext\n");
		printf("you want, and try again\n");
		return 1;
	}
	j=0;
	while(((i=fgetc(f))!=EOF)&&(j<2047))
	{
		if((i==13)||(i==10))
			continue;
		if(i=='\\')
		{
			i=fgetc(f);
			if(i==EOF)
				break;
			if(i=='\\')
			{
				scroll_text = i;
				continue;
			}
			if(i=='n')
			{
				for(k=0;k<32;k++)
					scroll_text = ' ';
				continue;
			}
			if(i=='/')
			{
				scroll_text = '/';
				continue;
			}

			
			scroll_text = '\\';
			scroll_text = i;
			continue;

		}

		if(i=='/')
		{
			i=fgetc(f);
			if(i==EOF)
				break;
			if(i=='/')
			{
				while(((i=fgetc(f))!=EOF))
				{
					if((i==10)||(i==13))
						break;
				}
				if(i==EOF)
					break;
				continue;

			}
			scroll_text = '/';
			scroll_text = i;
			continue;
		}

		scroll_text = i;
	}
	fclose(f);
	scroll_text = 0;

	return 0;
}

int main(int argc, char* argv[])
{

	FILE *f;	
	int filesize;

	char installer_nds[] = "installer.nds";
	char installer_gba[] = "installer.ds.gba";

	

	f=fopen(installer_nds,"rb+");
	if(f==NULL)
	{
		printf("Error: Could not find installer.nds\n");
		printf("Please build the firmware, and installer\n");
		printf("try again\n");
		return 1;
	}
	fseek(f,0,SEEK_END);
	if(ftell(f)>0x80000)
	{
		printf("Error: installer.nds too large\n");
		fclose(f);
		return 1;
	}
	fseek(f,0,SEEK_SET);
	filesize=fread(firmware_installer,1,0x80000,f);
	if(insert_scroller())
	{
		fclose(f);
		return 1;
	}
	fseek(f,0,SEEK_SET);
	fwrite(firmware_installer,1,filesize,f);
	fclose(f);

	f=fopen(installer_gba,"rb+");
	if(f==NULL)
	{
		printf("Error: Could not find installer.ds.gba\n");
		printf("Please build the firmware, and installer\n");
		printf("try again\n");
		return 1;
	}
	fseek(f,0,SEEK_END);
	if(ftell(f)>0x80000)
	{
		printf("Error: installer.ds.gba too large\n");
		fclose(f);
		return 1;
	}
	fseek(f,0,SEEK_SET);
	filesize=fread(firmware_installer,1,0x80000,f);
	if(insert_scroller())
	{
		fclose(f);
		return 1;
	}
	fseek(f,0,SEEK_SET);
	fwrite(firmware_installer,1,filesize,f);
	fclose(f);




	return 0;
}
